"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const flow = require("lodash/fp/flow");
const map = require("lodash/fp/map");
const reverse = require("lodash/fp/reverse");
const flatten = require("lodash/fp/flatten");
const compact = require("lodash/fp/compact");
const utils_1 = require("./utils");
class Magnet {
    constructor(app) {
        this.teardowns = [];
        this.app = app;
    }
    shutdown() {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield Promise.all(flow(flatten, compact, reverse, map((teardown) => {
                return teardown();
            }))(this.teardowns)
                .map(utils_1.reflect));
            const fails = utils_1.retrieveReflect(result, 'error');
            if (fails.length) {
                for (const fail of fails) {
                    this.app.log.error(fail);
                }
                throw new Error('Some modules cannot teardown');
            }
        });
    }
}
exports.default = Magnet;
//# sourceMappingURL=magnet.js.map